<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>medium</title>
    <link rel="stylesheet" href="style.css">
</head>
<body> 
<div>
    <div>
        <!-- Перший блок -->
        <h1>
            Using constraints & “magic numbers”
            to build responsive layouts in Figma
        </h1>
        <img src="https://miro.medium.com/max/828/1*Y2dJzfk5qWf-vI1MYiiTVw.png" alt="">
        <p>
            <i>This post is part of a series: <u>Building a design system with Figma at littleBits</u>.
                Read the previous post — how we created atomic components with Figma — <u>here</u>.</i>
        </p>
        <p>
            This year we faced a big challenge at Little Bits — launching 4 new apps on multiple platforms
            with both mobile and tablet layouts. We knew we needed a strong design system to do it right,
            particularly given our small team and short time span (6 months).<mark>ms with both mobile and tablet layouts.
            We knew we needed a strong design system to do it right,
            particularly given</mark>  our small team and short time span (6 months).
        </p>
        <p>
            Templates with responsive layouts played a key role in scaling our work. Here’s how we figured out the
            approach
            that worked for us in both Figma and React.
        </p>
    </div>
    <div>
        <!--Другий блок-->
        <h3>
            Magic Number
        </h3>
        <p>
            <mark>One thing that’s great to have at the heart of a design system is a ‘magic number’
                — it helps harmonize layout if sizes of text, graphic elements, margins, and padding,
                share a common numeric factor.</mark>
        </p>
        <p>
            Before we had any kind of system, we had mocks of several key screens that had been created
            to establish the visual direction of the app.
        </p>
        <img src="https://miro.medium.com/max/828/1*TqFz6lS9kuTmok-clI-X1Q.png" alt="">
        <p>
            We looked at the sizes and padding that had been ‘eyeballed’ in these designs, and found that
            things were mostly working off 8’s — buttons were 48px high, margins were mostly 24px, some headings
            were 32px, etc.
        </p>
        <p>
            Everything was close enough to nudge towards numbers that multiplied from 8 (and 8 in itself is a
            number that multiplies and divides well!). So 8 became our magic number for all things moving forward.
        </p>
        <img src="https://miro.medium.com/max/828/1*kmKS2fqTI7jtkDDdwm_VjQ.png" alt="">
        <p>
            From smallest to largest our buttons and form elements were made 32, 48, 56, 64, & 96px high; key headings
            & copy 48, 32, 24, & 16px; padding & gutters 16, 24, & 32px; larger layout cards would be 240px high.
        </p>
        <p>
            You get the picture…all the key sizes are multiples of 8!
        </p>


    </div>
    <div>
        <!--Третій блок-->
        <h3>
            Different Screen Sizes
        </h3>
        <p>
            Figma is great for building with responsive constraints — you can stretch your layouts and see how they
            will respond to changes in screen size. (If you’re new to constraints in Figma, check out <u>this beginner
            primer</u>  here.)
        </p>
        <p>
            You can even have elements pin to edges of a column:
        </p>
        <img src="https://miro.medium.com/max/640/1*dFGDlSVyHIKEtHyrcMGxHA.gif" alt="">
        <p>
            But it’s hard to create a single layout that will look good on most phones, still fit on a smaller phone
            like an iPhone SE,
            and feel full on a tablet.
        </p>
        <img src="https://miro.medium.com/max/700/1*-tgO36tfC_joP2YCHuKZhA.png" alt="">
        <p>
            Around half our users are loading the app on a tablet, so we didn’t want the experience there to feel like
            an afterthought.
            We didn’t want our designs to be compromised to fit with smaller screens either.
        </p>
        <p>
            In this case our designs were sympathetic to being proportionally scaled up and down, so we looked at the
            relationship between
            different screen sizes to get scaling ratios:
        </p>
        <img src="https://miro.medium.com/max/700/1*GzOYNQg-YmBExV_6o_kihg.png" alt="">
        <p>
            Then we rounded out the ratio values so we could keep whole numbers as we scaled:
        </p>
        <img src="https://miro.medium.com/max/700/1*UnBgpVjRk01Gbapzh9Vxng.png" alt="">
        <p>
            We baked these rules into how the React codebase calculated sizes (along with typical layout constraints).
        </p>
        <p>
            Because our templates were designed with this system in mind, when we tested the final build on tablets and
            smaller
            phones, things looked great right out of the box without needing extra adjustments.
        </p>
        <p>
            In our Figma designs we were able to have just one template design for each screen, and use a mixture of the
            scale
            tool and frame resizing to get a preview of how things would look on different devices.
        </p>
        <img src="https://miro.medium.com/max/700/1*ExxKlGR1Pl3dEzd9xocIJA.png" alt="">
        <p>
            There were other responsive design challenges to solve. The app had hundreds of videos and animations, we
            didn’t
            want to have to double handle multiple versions of the content files for different screen dimensions.
        </p>
        <p>
            We created all our video / animation content to work in 4:3 but with safe areas that could be cropped for
            16:9 screens.
        </p>
        <img src="https://miro.medium.com/max/700/1*VsTC2wy4CJEPIIQUCLEsNg.png" alt="">


    </div>
    <div>
        <!--Четвертий блок-->
        <h3>
            Text Sizes & Internationalization
        </h3>
        <p>
            With a ‘magic number’, sometimes there will need to be exceptions — with text in particular at smaller sizes
            a few pixels makes a lot of difference. But where 8’s didn’t fit, we tried to fall back to 4’s — so some
            text
            sizes were 12 & 20px.
        </p>
        <p>
            As well as needing variations for smaller copy, we were translating the app for 6 languages. Ideal text
            sizes
            were set in the templates for headings etc, but if a (German!) word didn’t fit within the available space,
            we
            created code to scale it down to the next heading size that would fit.
        </p>
        <img src="https://miro.medium.com/max/700/1*-8FrkflE7egP4wnkCtIilg.png" alt="">
        <p>
            So we ended up with a larger number of heading sizes than we used in the primary designs, but we kept a
            smooth transition of sizes when dropping from H1 to H6.
        </p>

    </div>
    <div>
        <!--П'ятий блок-->
        <h3>
            Summary
        </h3>
        <p>
            Most of our layouts are reasonably simple — centered elements, or 2–3 columns of content. We were lucky not
            to need responsive patterns besides the scaling system and basic layout constraints.
        </p>
        <p>
            The ‘magic number’ helps the design feel tight, it saves time when deciding how to position, size and space
            things, and of course it is much easier to code up a design that follows well defined consistent rules.
        </p>
        <p>
            Next step was to figure out the <u>correct workflow for our themes</u> .
        </p>
        <p>
            This post is part of a series <u>Building a Design System with Figma at littleBits</u> . Read the next post
            <u>Creating Themed Versions of a Master Design in Figma</u> .
        </p>
    </div>
</div>

<div></div>


</body>
</html>